// ߐژI.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"

#include <string.h>
#include  <stdlib.h> 
#include <stdio.h>
#include <math.h>

#include <ctype.h>
#include <time.h>

void CAL_AVE();
void CLS_II();
void OUT_II();
void CAL_II();
void CAL_UR_UI(double *Ox, double *Oy);
double fAs(double *v1, double *v2);
double fAc(double *v1, double *v2);
void CAL_Ac_As();

double WL,X1,X2,Y1,Y2,F,INA;
double Pr[1001],Pi[1001],Px1[1001],Px2[1001],Py1[1001],Py2[1001];
double Ac[1011],As[1011],dV;
double UR[141][141],UI[141][141],II[141][141];

int	Nx,Ny,Np,Ni;

void IN_FM();

void __stdcall main3()
{
	int i,j,N;
	double Ox,Oy,PI;

	PI=3.14159265358979;


	
	IN_FM();

	CLS_II();
	CAL_Ac_As();


	N=5;
	Ni=0;
	for( i=-N; i <= N; i++ )
	{
		for( j=-N; j <= N; j++ )
		{
			if(i*i+j*j <= N*N)
			{
				Ni=Ni+1;
				Ox=i*F*INA/N;
				Oy=j*F*INA/N;
				CAL_UR_UI(&Ox,&Oy);
				CAL_II();
			}
		}
	}


	CAL_AVE();
	OUT_II();
	

}


void IN_FM()
{
	int	i,j,k;
	FILE *f1;
	unsigned char FIN[8][700][100];
	int	c;


	i=0;
	j=0;
	k=0;

	//f1=fopen("C:\\BVA_C_APP\\IN_FM.txt","r");
	errno_t err=fopen_s(&f1,"IN_FM.txt","r");

	while((c=fgetc(f1)) != EOF)
	{
		if(i>7){i=7;}
		if(j>699){j=699;}
		if(k>99){k=99;}
		if(c == '\n')
		{
			FIN[i][j][k]=0;
			//UR[i][j]=atof((const char *)FIN[i]);
			i=0;
			j=j+1;
			k=0;
		}
		else
		{
			if(c == '\t')
			{
				FIN[i][j][k]=0;
				//UR[i][j]=atof((const char *)FIN[i]);
				i=i+1;
				k=0;
			}
			else
			{
				if(c != '\r')
				{
					FIN[i][j][k]=c;
					k=k+1;
				}
			}
		}

	}
	fclose(f1);

	WL=atof((const char *)FIN[2][2]);
	F=atof((const char *)FIN[2][3]);
	INA=atof((const char *)FIN[2][4]);

	X1=atof((const char *)FIN[2][5]);
	X2=atof((const char *)FIN[2][6]);
	Nx=atoi((const char *)FIN[2][7]);
	Y1=atof((const char *)FIN[2][8]);
	Y2=atof((const char *)FIN[2][9]);
	Ny=atoi((const char *)FIN[2][10]);


	Np=atoi((const char *)FIN[2][11]);

	for(i=0;i<Np;i++)
	{
		Pr[i]=atof((const char *)FIN[1][i+14]);
		Pi[i]=atof((const char *)FIN[2][i+14]);
		Px1[i]=atof((const char *)FIN[3][i+14]);
		Px2[i]=atof((const char *)FIN[4][i+14]);
		Py1[i]=atof((const char *)FIN[5][i+14]);
		Py2[i]=atof((const char *)FIN[6][i+14]);
	}
	

	

}



void CAL_Ac_As()
{
	int i,N;
	double h,v1,v2,v3;
	double SAc,SAs,fc1,fc2,fc3,fs1,fs2,fs3;
	double PI=3.14159265358979;

	dV=0.02;
	N=1000;
	h=dV/2;
	SAc=0;
	SAs=0;
	Ac[0]=0;
	As[0]=0;
	for (i=0;i<=N;i++)
	{
		v1=2*i*h;
		v2=v1+h;
		v3=v2+h;
		fc1=cos(PI*v1*v1/2);
		fc2=cos(PI*v2*v2/2);
		fc3=cos(PI*v3*v3/2);
		fs1=sin(PI*v1*v1/2);
		fs2=sin(PI*v2*v2/2);
		fs3=sin(PI*v3*v3/2);
		SAc=SAc+(fc1+4*fc2+fc3)*h/3;
		SAs=SAs+(fs1+4*fs2+fs3)*h/3;
		Ac[i+1]=SAc;
		As[i+1]=SAs;
	}

}

double fAc(double *v1, double *v2)
{
	double Acr,Ac1,Ac2,Vv1,Vv2,dv,Mv,X;
	int Sv1,Sv2,Nv,N;

	N=1000;

	if ( *v1 < 0 ) 
	{
		Sv1=-1;
		Vv1=fabs(*v1);
	}
	else
	{ 
		Sv1=1;
		Vv1=*v1;
	}

	if ( *v2 < 0 ) 
	{
		Sv2=-1;
		Vv2=fabs(*v2);
	}
	else
	{ 
		Sv2=1;
		Vv2=*v2;
	}

	dv=dV;
	Mv = modf( Vv1/dv, &X );
	Nv=int(Vv1/dv);
	if(Nv < N)
	{Ac1=Sv1*(Ac[Nv]+((Ac[Nv+1])-(Ac[Nv]))*Mv);}
	else
	{Ac1=Sv1*0.5;}

	Mv = modf( Vv2/dv, &X );
	Nv=int(Vv2/dv);
	if(Nv < N)
	{Ac2=Sv2*(Ac[Nv]+((Ac[Nv+1])-(Ac[Nv]))*Mv);}
	else
	{Ac2=Sv2*0.5;}

	Acr=Ac2-Ac1;
	return Acr;

}

double fAs(double *v1, double *v2)
{
	double Asr,As1,As2,Vv1,Vv2,dv,Mv,X;
	int Sv1,Sv2,Nv,N;

	N=1000;

	if ( *v1 < 0 ) 
	{
		Sv1=-1;
		Vv1=fabs(*v1);
	}
	else
	{ 
		Sv1=1;
		Vv1=*v1;
	}

	if ( *v2 < 0 ) 
	{
		Sv2=-1;
		Vv2=fabs(*v2);
	}
	else
	{ 
		Sv2=1;
		Vv2=*v2;
	}

	dv=dV;
	Mv = modf( Vv1/dv, &X );
	Nv=int(Vv1/dv);
	if(Nv < N)
	{As1=Sv1*(As[Nv]+((As[Nv+1])-(As[Nv]))*Mv);}
	else
	{As1=Sv1*0.5;}

	Mv = modf( Vv2/dv, &X );
	Nv=int(Vv2/dv);
	if(Nv < N)
	{As2=Sv2*(As[Nv]+((As[Nv+1])-(As[Nv]))*Mv);}
	else
	{As2=Sv2*0.5;}

	Asr=As2-As1;
	return Asr;

}



void CAL_UR_UI(double *Ox, double *Oy)
{
	int i,j,k;
	double X,Y,v1x,v2x,v1y,v2y;
	double Acv,Asv,Acw,Asw;
	double Ar,Ai;
	double dx,dy;



	for( j=0; j <=Nx; j++ )
	{
		for( k=0; k <=Ny; k++ )
		{
			UR[j][k]=0;
			UI[j][k]=0;
		}
	}

	dx=(X2-X1)/Nx;
	dy=(Y2-Y1)/Ny;

	for( i=0; i < Np; i++ )
	{
		for( j=0; j<=Nx; j++ )
		{
			X=X1+dx*j;
			for( k=0; k <=Ny; k++ )
			{
				Y=Y1+dy*k;
				v1x=sqrt(2/(WL*F))*(Px1[i]-X-*Ox);
				v2x=sqrt(2/(WL*F))*(Px2[i]-X-*Ox);
				Acv=fAc(&v1x,&v2x);
				Asv=fAs(&v1x,&v2x);

				v1y=sqrt(2/(WL*F))*(Py1[i]-Y-*Oy);
				v2y=sqrt(2/(WL*F))*(Py2[i]-Y-*Oy);
				Acw=fAc(&v1y,&v2y);
				Asw=fAs(&v1y,&v2y);

				Ar=(Acv*Asw+Asv*Acw)/2;
				Ai=(Asv*Asw-Acv*Acw)/2;
				

				UR[j][k]=UR[j][k]+Pr[i]*Ar-Pi[i]*Ai;
				UI[j][k]=UI[j][k]+Pr[i]*Ai+Pi[i]*Ar;

			}
		}
	}
	
}



void CAL_II()
{
	int j,k;

	for( j=0; j<=Nx; j++ )
	{
		for( k=0; k <=Ny; k++ )
		{
			II[j][k]=II[j][k]+UR[j][k]*UR[j][k]+UI[j][k]*UI[j][k];
		}
	}
}

void OUT_II()
{
	int i,j,k;
	FILE *f1;
	char	s1[256];
	double X,Y;

	//N=180;

	//f1=fopen("OUT_M.xls","w");
	errno_t err=fopen_s(&f1,"OUT_M.xls","w");

	fputs("\t",f1);

	for (i=0;i<=Nx;i++)
	{
		X=X1+i*(X2-X1)/Nx;

		//sprintf(s1,"%f\t",X);
		k=sprintf_s(s1,256,"%f\t",X);
		fputs(s1,f1);

	}
	fputs("\n",f1);
	

	for (j=0;j<=Ny;j++)
	{
		Y=Y1+j*(Y2-Y1)/Ny;
		//sprintf(s1,"%f\t",Y);
		k=sprintf_s(s1,256,"%f\t",Y);
		fputs(s1,f1);

		for (i=0;i<=Nx;i++)
		{
			//sprintf(s1,"%f\t",II[i][j]);
			k=sprintf_s(s1,256,"%f\t",II[i][j]);
			fputs(s1,f1);
		}
		fputs("\n",f1);
	}
	fclose(f1);

}

void CLS_II()
{
	int j,k;

	for( j=0; j<=Nx; j++ )
	{
		for( k=0; k <=Ny; k++ )
		{
			II[j][k]=0;
		}
	}

}

void	CAL_AVE()
{
	int j,k;

	for( j=0; j<=Nx; j++ )
	{
		for( k=0; k <=Ny; k++ )
		{
			II[j][k]=II[j][k]/Ni;
		}
	}

}



